#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

##--------------------------------------##
#              WxGeometrie               #
#        Global search utility           #
##--------------------------------------##
#    WxGeometrie
#    Dynamic geometrie, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005-2006  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


import os as __os__

def gs(chaine, case = True, extensions =(".py", ".pyw"), exclude_prefixe = ("tmp_", "Copie"), maximum = 100):
    if not case:
        chaine = chaine.lower()
    repertoires=__os__.walk(__os__.getcwd())
    fichiers = []
    for root, dirs, files in repertoires:
        if True in [(__os__.sep + prefixe in root) for prefixe in exclude_prefixe]:
            continue
        files = [f for f in files if True not in [f.startswith(prefixe) for prefixe in exclude_prefixe]]
        files = [f for f in files if f[f.rfind("."):] in extensions]
 
        fichiers += [root + __os__.sep + f for f in files]
    n_lignes = 0    
    for f in fichiers:
        fichier = open(f, "r")
        n = 1
        for s in fichier:
            if not case:
                s = s.lower()
            if s.find(chaine) <> -1:
                print "in %s " %f
                print "line %s:   %s" %(n, s)
                n_lignes += 1
                if n_lignes > maximum:
                    print "Maximum output exceeded...!"
                    return False
            n += 1
        fichier.close()
    return True
    
def gr(chaine, chaine_bis, exceptions = (), extensions = (".py", ".pyw")):
    y = yes = True
    n = no = False
    txt_exceptions = exceptions and "but " + ", ".join(exceptions) + " " or ""
    b = input("Warning: Replace string '%s' by string '%s' in ALL files %s[y/n] ?" %(chaine, chaine_bis, txt_exceptions))
    if b is not True:
        return False
    repertoires=__os__.walk(__os__.getcwd())
    fichiers = []
    for r in repertoires:
        fichiers += [r[0] + __os__.sep + f for f in r[2] if f[f.rfind("."):] in extensions and f not in exceptions]
    n_lignes = 0    
    for f in fichiers:
        fichier = open(f, "r")
        s = fichier.read()
        fichier.close()
        fichier = open(f, "w")
        s = fichier.write(s.replace(chaine, chaine_bis))
        fichier.close()
    return True
    