# -*- coding: iso-8859-1 -*-
from __future__ import division # 1/2 == .5 (par defaut, 1/2 == 0)

##########################################
#            Modules                      
##########################################
#    WxGeometrie
#    Dynamic geometrie, graph plotter, and more for french mathematic teachers.
#    Copyright (C) 2005  Nicolas Pourcelot
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from LIB import *
from API.menu import MenuBar
from API.panel import Panel_simple

__liste__ = []
for module in param.modules:
    try:
        exec("import modules.%s" %module)
        
        menus = [objet for objet in getattr(modules, module).__dict__.values() if isinstance(objet, type) and issubclass(objet, MenuBar) and objet.__name__ <> "MenuBar"]
        if len(menus) > 1 and param.debug:
            print menus
            raise IndexError, "Plusieurs classes heritent de MenuBar dans le module %s." %module
        if len(menus) == 0 and param.debug:
            raise IndexError, "Aucune classe n'herite de MenuBar dans le module %s." %module
        getattr(modules, module).__menu__ = menus[0]
        
        panels = [objet for objet in getattr(modules, module).__dict__.values() if isinstance(objet, type) and issubclass(objet, Panel_simple) and not objet.__name__ in ("Panel_simple", "Panel_API_graphique")]
        if len(panels) > 1 and param.debug:
            print panels
            raise IndexError, "Plusieurs classes heritent de Panel_simple dans le module %s." %module
        if len(panels) == 0 and param.debug:
            raise IndexError, "Aucune classe n'herite de Panel_simple dans le module %s." %module
        getattr(modules, module).__panel__ = panels[0]
        
        __liste__.append(module)
        
    except:
        debug("Impossible d'importer le module %s." %module)
        if param.debug:
            raise
    
    
def liste(nom = None):
    "Retourne le module 'nom', ou a defaut la liste des modules."
    if nom:
        return getattr(modules, nom)
    return __liste__